import { IMessageEvent } from 'websocket'
import { IncomingPacket } from './structures/server'
// import { SubscribeMessage } from './structures/subscribe'

export function connect (url: string): void {
  const webSocket = new WebSocket(url)
  webSocket.binaryType = 'arraybuffer'
  webSocket.onmessage = onMessage

  webSocket.onopen = () => {
    console.log('Connected!')
    // const subscribeMessage = new SubscribeMessage(0x0001)
    const tmp = Uint8Array.from([0x00, 0x00, 0x00, 0x02, 0x00, 0x01])
    console.log(tmp)
    webSocket.send(tmp)
  }
}

function onMessage (event: IMessageEvent): void {
  console.log('New message.')
  console.log(event.data)
  console.log(new IncomingPacket(event.data as ArrayBuffer))
}
